﻿using UnityEngine;
using System.Collections;
using System;
using System.Linq;
using System.Runtime.InteropServices;

public class tower1rtcmix : MonoBehaviour {
	int objno = 1; // change this for multiple RTcmix instantiations
    rtcmixmain RTcmix;
    private bool did_start = false;

    private float Rval;
    GameObject rolleything;

    public void Awake()
    {
        RTcmix = GameObject.Find("RTcmixmain").GetComponent<rtcmixmain>();
        rolleything = GameObject.Find("rolleything");
    }

    void Start () {
        RTcmix.initRTcmix(objno);

		String score = "x = 0.5 " +
			"ampenv = maketable(\"line\", 1000, 0,0, 1,1, 2,0) "  +
			"MAXBANG(0) ";
        RTcmix.SendScore(score, objno);

        did_start = true;
	}

	// Update is called once per frame
	void Update () {
		Transform rolleytransform = rolleything.transform;

		float distance = Vector3.Distance (rolleytransform.position, transform.position);

		// distance is between 65 and 4.5, scale to between 1.0 - 3.999
		Rval = (float)(3.999 - (3.0 * (distance-4.5)/60.0));
	}

	// this function is called by unity for every buffer of sound samples computed
	void OnAudioFilterRead(float[] data, int channels){
        if (!did_start) return;

        RTcmix.runRTcmix(data, objno, 0);

        if (RTcmix.checkbangRTcmix(objno) == 1) {
            String score = "R = " + Rval + "  " +
                "ampmult = (R-1.0)/3.0 " +
                "if (R > 1.0) { " +
                "	x = R * x * (1.0 - x) " +
                "	freq = x * 1000 + 100 " +
                "} " +
                "if (ampmult > 0) " +
                "	WAVETABLE(0, 0.2, 10000*ampenv*ampmult, freq, random()) " +
                "MAXBANG(0.1) ";
            RTcmix.SendScore(score, objno);
		}
    }

    void OnApplicationQuit()
    {
        did_start = false;
        RTcmix = null;
    }
}
	
