﻿using UnityEngine;
using System.Collections;
using System;
using System.Linq;
using System.Runtime.InteropServices;

public class tower2rtcmix : MonoBehaviour {
	int objno = 2; // change this for multiple RTcmix instantiations
    rtcmixmain RTcmix;
    private bool did_start = false;

    private float Rval;
    GameObject rolleything;

    public void Awake()
    {
        RTcmix = GameObject.Find("RTcmixmain").GetComponent<rtcmixmain>();
        rolleything = GameObject.Find("rolleything");
    }

    void Start()
    {
        RTcmix.initRTcmix(objno);

		String score = "x1 = 0.5 " +
			"ampenv1 = maketable(\"line\", 1000, 0,0, 1,1, 10,0) " +
			"indexenv = maketable(\"line\", 1000, 0,0.1, 1,1, 2,0) " +
			"wave = maketable(\"wave\", 1000, \"sine\") " +
			"notes = { 7.00, 7.02, 7.04, 7.06, 7.08, 7.10, 8.00, 8.02, 8.04, " +
			"	8.06, 8.08, 9.00 } " +
			"lnotes = len(notes) " +
			"MAXBANG(0) ";
        RTcmix.SendScore(score, objno);

        did_start = true;
	}

	// Update is called once per frame
	void Update () {
		Transform rolleytransform = rolleything.transform;

		float distance = Vector3.Distance (rolleytransform.position, transform.position);

		// distance is between 65 and 4.5, scale to between 1.0 - 3.999
		Rval = (float)(3.999 - (3.0 * (distance-4.5)/60.0));
	}

	// this function is called by unity for every buffer of sound samples computed
	void OnAudioFilterRead(float[] data, int channels){
        if (!did_start) return;

        RTcmix.runRTcmix(data, objno, 0);

        if (RTcmix.checkbangRTcmix(objno) == 1)
        {
            String score = "R = " + Rval + "  " +
                "if (R > 3.999) R = 3.99 " +
                "ampmult1 = (R-1.0)/3.0 " +
                "if (R > 1.0) " +
                "	x1 = R * x1 * (1.0 - x1) " +
                "index = trunc(x1 * lnotes) " +
                "note = notes[index] " +
                "freq = cpspch(note) " +
                "if (ampmult1 > 0) " +
                "	FMINST(0, 0.2, 20000*ampenv1*ampmult1, freq, 2*freq, 1, 3, random(), wave, indexenv) " +
                "MAXBANG(0.1) ";
            RTcmix.SendScore(score, objno);
        }
	}

    void OnApplicationQuit()
    {
        did_start = false;
        RTcmix = null;
    }
}

