﻿using UnityEngine;
using System.Collections;
using System;
using System.Linq;
using System.Runtime.InteropServices;

public class tower3rtcmix : MonoBehaviour {
	int objno = 3; // change this for multiple RTcmix instantiations
    rtcmixmain RTcmix;
    private bool did_start = false;

    private float Rval;
    GameObject rolleything;

    public void Awake()
    {
        RTcmix = GameObject.Find("RTcmixmain").GetComponent<rtcmixmain>();
        rolleything = GameObject.Find("rolleything");
    }

    void Start()
    {
        RTcmix.initRTcmix(objno);

        String score = "bus_config(\"WAVETABLE\", \"aux 0-1 out\") " +
			"bus_config(\"MOOGVCF\", \"aux 0-1 in\", \"out 0-1\") " +
			"ampfreq = makeconnection(\"inlet\", 1, 50) " +
			"wave = maketable(\"wave\", 1000, \"saw\") " +
			"WAVETABLE(0, 9999, 20000, 5.00, 0.5, wave) " +
			"WAVETABLE(0, 9999, 20000, 5.001, 0.5, wave) " +
			"WAVETABLE(0, 9999, 20000, 4.1187, 0.5, wave) " +
			"MOOGVCF(0, 0, 9999, ampfreq/100, 0, 0.5, 0, ampfreq*100, 0.1) ";
        RTcmix.SendScore(score, objno);

        did_start = true;
	}

	// Update is called once per frame
	void Update () {
        if (!did_start) return;

		Transform rolleytransform = rolleything.transform;

		float distance = Vector3.Distance (rolleytransform.position, transform.position);

		// distance is between 65 and 4.5, scale between 0 - 100
		float pval = (float)(1.0 - (distance-4.5)/60.0);
		pval = pval * 100.0f;

		if (pval > 0.0) {
            RTcmix.setpfieldRTcmix(1, pval, objno);
		}
	}

	// this function is called by unity for every buffer of sound samples computed
	void OnAudioFilterRead(float[] data, int channels){
        if (!did_start) return;

        RTcmix.runRTcmix(data, objno, 0);
	}

    void OnApplicationQuit()
    {
        did_start = false;
        RTcmix = null;
    }
}

