﻿using UnityEngine;
using System.Collections;
using System;
using System.Linq;
using System.Runtime.InteropServices;


public class windsound : MonoBehaviour {
	int objno = 0; // change this for multiple RTcmix instantiations
    rtcmixmain RTcmix;
    private bool did_start = false;


    public void Awake()
    {
        RTcmix = GameObject.Find("RTcmixmain").GetComponent<rtcmixmain>();
    }

    void Start () {
        RTcmix.initRTcmix(objno);

		String score = "bus_config(\"IINOISE\", \"aux 0-1 out\") " +
			"bus_config(\"GVERB\", \"aux 0-1 in\", \"out 0-1\") " +
			"ampenv = maketable(\"line\", 1000, 0,0, 1,1, 2,0) " +
			"GVERB(0, 0, 9999, 0.9, 178.0, 17.0, 0.71, 0.34, -20.0, -11.0, -9.0, 7.0) " +
			"MAXBANG(0.1) ";
        RTcmix.SendScore(score, objno);

        did_start = true;
	}

	// this function is called by unity for every buffer of sound samples computed
	void OnAudioFilterRead(float[] data, int channels){
        if (!did_start) return;

        RTcmix.runRTcmix(data, objno, 0);

        if (RTcmix.checkbangRTcmix(objno) == 1) {
            String score = "setup(irand(150, 400), 40, 1) " +
                "IINOISE(0, irand(7, 11), 20000*ampenv, 0.5) " +
                "MAXBANG(irand(5, 10)) ";
            RTcmix.SendScore(score, objno);
        }
	}

    void OnApplicationQuit()
    {
        did_start = false;
        RTcmix = null;
    }
}

